Loading...
Searching...
No Matches
juce::PluginDirectoryScanner Class Reference

## Detailed Description

Scans a directory for plugins, and adds them to a KnownPluginList.

To use one of these, create it and call scanNextFile() repeatedly, until it returns false.

The documentation for this class was generated from the following file:

- juce_audio_processors/scanning/juce_PluginDirectoryScanner.h

## Public Member Functions

| PluginDirectoryScanner (KnownPluginList &listToAddResultsTo, AudioPluginFormat &formatToLookFor, FileSearchPath directoriesToSearch, bool searchRecursively, const File &deadMansPedalFile, bool allowPluginsWhichRequireAsynchronousInstantiation=false)
| Creates a scanner.
| ~PluginDirectoryScanner ()
| Destructor.
void | setFilesOrIdentifiersToScan (const StringArray &filesOrIdentifiersToScan)
| Sets a specific list of filesOrIdentifiersToScan to scan.
bool | scanNextFile (bool dontRescanIfAlreadyInList, String &nameOfPluginBeingScanned)
| Tries the next likely-looking file.
bool | skipNextFile ()
| Skips over the next file without scanning it.
String | getNextPluginFileThatWillBeScanned () const
| Returns the description of the plugin that will be scanned during the next call to scanNextFile().
float | getProgress () const
| Returns the estimated progress, between 0 and 1.
const StringArray & | getFailedFiles () const noexcept
| This returns a list of all the filenames of things that looked like being a plugin file, but which failed to open for some reason.

## Static Public Member Functions

static void | applyBlacklistingsFromDeadMansPedal (KnownPluginList &listToApplyTo, const File &deadMansPedalFile)
| Reads the given dead-mans-pedal file and applies its contents to the list.

## Constructors and Destructors

## PluginDirectoryScanner()

juce::PluginDirectoryScanner::PluginDirectoryScanner | ( | KnownPluginList & | listToAddResultsTo,
|  | AudioPluginFormat & | formatToLookFor,
|  | FileSearchPath | directoriesToSearch,
|  | bool | searchRecursively,
|  | const File & | deadMansPedalFile,
|  | bool | allowPluginsWhichRequireAsynchronousInstantiation = false )

Creates a scanner.

Parameters

  listToAddResultsTo | this will get the new types added to it.
  formatToLookFor | this is the type of format that you want to look for
  directoriesToSearch | the path to search
  searchRecursively | true to search recursively

  deadMansPedalFile

  if this isn't File(), then it will be used as a file to store the names of any plugins that crash during initialisation. If there are any plugins listed in it, then these will always be scanned after all other possible files have been tried - in this way, even if there's a few dodgy plugins in your path, then a couple of rescans will still manage to find all the proper plugins. It's probably best to choose a file in the user's application data directory (alongside your app's settings file) for this. The file format it uses is just a list of filenames of the modules that failed.

  allowPluginsWhichRequireAsynchronousInstantiation | If this is false then the scanner will exclude plug-ins asynchronous creation - such as AUv3 plug-ins.

## ~PluginDirectoryScanner()

juce::PluginDirectoryScanner::~PluginDirectoryScanner | ( |  | ) |

Destructor.

## Member Functions

## setFilesOrIdentifiersToScan()

void juce::PluginDirectoryScanner::setFilesOrIdentifiersToScan | ( | const StringArray & | filesOrIdentifiersToScan | ) |

Sets a specific list of filesOrIdentifiersToScan to scan.

N.B. This list must match the format passed to the constructor.

See also
  AudioPluginFormat::searchPathsForPlugins

## scanNextFile()

bool juce::PluginDirectoryScanner::scanNextFile | ( | bool | dontRescanIfAlreadyInList,
|  | String & | nameOfPluginBeingScanned )

Tries the next likely-looking file.

If dontRescanIfAlreadyInList is true, then the file will only be loaded and re-tested if it's not already in the list, or if the file's modification time has changed since the list was created. If dontRescanIfAlreadyInList is false, the file will always be reloaded and tested. The nameOfPluginBeingScanned will be updated to the name of the plugin being scanned before the scan starts.

Returns false when there are no more files to try.

## skipNextFile()

bool juce::PluginDirectoryScanner::skipNextFile | ( |  | ) |

Skips over the next file without scanning it.

Returns false when there are no more files to try.

## getNextPluginFileThatWillBeScanned()

String juce::PluginDirectoryScanner::getNextPluginFileThatWillBeScanned | ( |  | ) | const

Returns the description of the plugin that will be scanned during the next call to scanNextFile().

This is handy if you want to show the user which file is currently getting scanned.

## getProgress()

float juce::PluginDirectoryScanner::getProgress | ( |  | ) | const

inline

Returns the estimated progress, between 0 and 1.

## getFailedFiles()

const StringArray & juce::PluginDirectoryScanner::getFailedFiles | ( |  | ) | const

inline noexcept

This returns a list of all the filenames of things that looked like being a plugin file, but which failed to open for some reason.

## applyBlacklistingsFromDeadMansPedal()

void juce::PluginDirectoryScanner::applyBlacklistingsFromDeadMansPedal | ( | KnownPluginList & | listToApplyTo,
|  | const File & | deadMansPedalFile )

static

Reads the given dead-mans-pedal file and applies its contents to the list.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited